Index: tmp/org.txm.analec.rcp/src/org/txm/analec/AnalecCorpora.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/AnalecCorpora.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/AnalecCorpora.java	(revision 927)
@@ -11,27 +11,27 @@
 import visuAnalec.vue.Vue;
 
 /**
- * Manages Analec corpus : the corpus are associated with TXM MainCorpus names
+ * Manages Analec corpus : the corpus are associated with TXM MainCorpus objects
  * 
  * @author mdecorde
  *
  */
 public class AnalecCorpora {
-	private static final HashMap<String, Corpus> corpora = new HashMap<String, Corpus>();
-	private static final HashMap<String, Vue> vues = new HashMap<String, Vue>();
+	private static final HashMap<MainCorpus, Corpus> corpora = new HashMap<MainCorpus, Corpus>();
+	private static final HashMap<MainCorpus, Vue> vues = new HashMap<MainCorpus, Vue>();
 
 	/**
 	 * Create the ec file if needed, store a reference to the corpus if not already done.
 	 * 
-	 * @param name
+	 * @param mcorpus
 	 * @return the Corpus loaded and stored
 	 */
-	public static Corpus getCorpus(String name) {
-		File fichierCorpus = new File(Toolbox.getTxmHomePath(), "corpora/"+name+"/analec/"+name+".ec"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-		File fichierVue = new File(Toolbox.getTxmHomePath(), "corpora/"+name+"/analec/"+name+".ecv");
+	public static Corpus getCorpus(MainCorpus mcorpus) {
+		File fichierCorpus = new File(mcorpus.getBaseDirectory(), "analec/"+mcorpus+".ec"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		File fichierVue = new File(mcorpus.getBaseDirectory(), "analec/"+mcorpus+".ecv");
 		Corpus corpus = null;
-		if (AnalecCorpora.corpora.containsKey(name)) {
-			corpus = AnalecCorpora.corpora.get(name);
+		if (AnalecCorpora.corpora.containsKey(mcorpus)) {
+			corpus = AnalecCorpora.corpora.get(mcorpus);
 		} else {
 			corpus = new Corpus();
 			
@@ -49,9 +49,9 @@
 				}
 			}
 
-			AnalecCorpora.corpora.put(name, corpus);
+			AnalecCorpora.corpora.put(mcorpus, corpus);
 			
-			Vue vue = getVue(name);
+			Vue vue = getVue(mcorpus);
 			
 //TODO: does not work :( 
 			if (fichierVue.exists()) {
@@ -59,6 +59,10 @@
 					System.out.println("Warning: Fail to open corpus Vue file: "+fichierVue);
 					//return null;
 				}
+				String[] types = vue.getTypesUnitesAVoir();
+				if (types == null || types.length == 0) {
+					vue.retablirVueParDefaut();
+				}
 			} else {
 				if (!FichiersJava.enregistrerVue(vue, fichierVue)) {
 					System.out.println("Warning: Fail to create corpus Vue file: "+fichierVue);
@@ -70,10 +74,10 @@
 	}
 	
 	public static boolean isAnnotationStructureReady(org.txm.searchengine.cqp.corpus.Corpus corpus) {
-		return isAnnotationStructureReady(corpus.getName());
+		return isAnnotationStructureReady(corpus.getMainCorpus());
 	}
 	
-	public static boolean isAnnotationStructureReady(String name) {
+	public static boolean isAnnotationStructureReady(MainCorpus name) {
 		if (AnalecCorpora.corpora.containsKey(name)) {
 			return !AnalecCorpora.corpora.get(name).getStructure().isVide();
 		} else {
@@ -91,7 +95,7 @@
 	 * @param name
 	 * @return the corpus Vue
 	 */
-	public static Vue getVue(String name) {
+	public static Vue getVue(MainCorpus name) {
 		if (!vues.containsKey(name)) {
 			if (!corpora.containsKey(name)) {
 				getCorpus(name);
@@ -103,38 +107,39 @@
 		return vues.get(name);
 	}
 
-	public static boolean saveCorpus(String name) {
-		Corpus corpus = getCorpus(name);
-		Vue vue = getVue(name);
-		File dir = new File(Toolbox.getTxmHomePath(), "corpora/"+name+"/analec/"); //$NON-NLS-1$ //$NON-NLS-2$
+	public static boolean saveCorpus(MainCorpus mcorpus) {
+		Corpus corpus = getCorpus(mcorpus);
+		Vue vue = getVue(mcorpus);
+		File dir = new File(mcorpus.getBaseDirectory(), "analec/"); //$NON-NLS-1$ //$NON-NLS-2$
 		dir.mkdir();
-		File fichierCorpus = new File(dir,name+".ec"); //$NON-NLS-1$
-		File fichierVueCorpus = new File(dir,name+".ecv"); //$NON-NLS-1$
-		return FichiersJava.enregistrerCorpus(corpus, fichierCorpus) && FichiersJava.enregistrerVue(vue, fichierVueCorpus);
+		File fichierCorpus = new File(dir,mcorpus+".ec"); //$NON-NLS-1$
+		File fichierVueCorpus = new File(dir,mcorpus+".ecv"); //$NON-NLS-1$
+		return FichiersJava.enregistrerCorpus(corpus, fichierCorpus) 
+				&& FichiersJava.enregistrerVue(vue, fichierVueCorpus);
 	}
 
 	public static Vue getVue(Corpus corpus) {
-		for (String name : corpora.keySet()) {
-			if (corpora.get(name) == corpus) return vues.get(name);
+		for (MainCorpus mcorpus : corpora.keySet()) {
+			if (corpora.get(mcorpus) == corpus) return vues.get(mcorpus);
 		}
 		return null;
 	}
 
 	public static boolean saveCorpus(Corpus corpus) {
-		for (String name : corpora.keySet()) {
-			if (corpora.get(name) == corpus) return saveCorpus(name);
+		for (MainCorpus mcorpus : corpora.keySet()) {
+			if (corpora.get(mcorpus) == corpus) return saveCorpus(corpus);
 		}
 		return false;
 	}
 
-	public static void removeCorpus(String name) {
-		if (!vues.containsKey(name)) {vues.remove(name);}
-		if (!corpora.containsKey(name)) {corpora.remove(name);}
+	public static void removeCorpus(MainCorpus mcorpus) {
+		if (!vues.containsKey(mcorpus)) {vues.remove(mcorpus);}
+		if (!corpora.containsKey(mcorpus)) {corpora.remove(mcorpus);}
 	}
 
 	public static void revert(MainCorpus corpus) {
-		corpora.remove(corpus.getName());
-		vues.remove(corpus.getName());
+		corpora.remove(corpus);
+		vues.remove(corpus);
 		corpus.setIsModified(false);
 	}
 }
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportGlozzAnnotations.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportGlozzAnnotations.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportGlozzAnnotations.java	(revision 927)
@@ -67,7 +67,7 @@
 		}
 		
 		MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
-		Corpus analecCorpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		Corpus analecCorpus = AnalecCorpora.getCorpus(mainCorpus);
 		analecCorpus.clearAll(); // remove all : annotations, structure
 		
 		System.out.println(Messages.ImportGlozzAnnotations_2+aamfile);
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveVue.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveVue.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveVue.java	(revision 927)
@@ -32,7 +32,7 @@
 		}
 		
 		MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
-		corpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		corpus = AnalecCorpora.getCorpus(mainCorpus);
 
 		File binaryCorpusDirectory = mainCorpus.getBaseDirectory();
 		File fichierVue = new File(binaryCorpusDirectory, "/analec/"+mainCorpus.getName()+".ecv"); //$NON-NLS-1$ //$NON-NLS-2$
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ExportTEICorpus.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ExportTEICorpus.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ExportTEICorpus.java	(revision 927)
@@ -48,9 +48,8 @@
 			}
 			
 			final MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
-			final String name = mainCorpus.getName();
-			final Corpus analecCorpus = AnalecCorpora.getCorpus(name.toUpperCase());
-			final Vue vue = AnalecCorpora.getVue(name);
+			final Corpus analecCorpus = AnalecCorpora.getCorpus(mainCorpus);
+			final Vue vue = AnalecCorpora.getVue(mainCorpus);
 			outputDirectory.mkdirs();
 			JobHandler job = new JobHandler(mainCorpus.getName()+Messages.ExportTEICorpus_1) {
 				
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveStructure.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveStructure.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveStructure.java	(revision 927)
@@ -35,7 +35,7 @@
 	}
 	
 	public static boolean save(MainCorpus mainCorpus) {
-		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus);
 
 		File binaryCorpusDirectory = mainCorpus.getBaseDirectory();
 		File fichierStructure = new File(binaryCorpusDirectory, "/analec/"+mainCorpus.getName()+".ecs"); //$NON-NLS-1$ //$NON-NLS-2$
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportTEIAnnotations.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportTEIAnnotations.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportTEIAnnotations.java	(revision 927)
@@ -51,9 +51,8 @@
 			}
 			
 			final MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
-			final String name = mainCorpus.getName();
-			final Corpus analecCorpus = AnalecCorpora.getCorpus(name.toUpperCase());
-			final Vue vue = AnalecCorpora.getVue(name);
+			final Corpus analecCorpus = AnalecCorpora.getCorpus(mainCorpus);
+			final Vue vue = AnalecCorpora.getVue(mainCorpus);
 			
 			JobHandler job = new JobHandler(mainCorpus.getName()+Messages.ImportTEIAnnotations_1) {
 				
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveCorpus.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveCorpus.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveCorpus.java	(revision 927)
@@ -45,10 +45,9 @@
 	public static boolean save(final MainCorpus mainCorpus, ExecutionEvent event) {
 		File binaryCorpusDirectory = mainCorpus.getBaseDirectory();
 		File fichierCorpus = new File(binaryCorpusDirectory, "/analec/"+mainCorpus.getName()+".ec"); //$NON-NLS-1$ //$NON-NLS-2$
-		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus);
 		System.out.println(Messages.SaveCorpus_3+corpus+Messages.SaveCorpus_1+fichierCorpus);
-
-		if (!FichiersJava.enregistrerCorpus(corpus, fichierCorpus)) {
+		if (!AnalecCorpora.saveCorpus(mainCorpus)) {
 			System.out.println(Messages.SaveCorpus_5);
 			return false;
 		}
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportGlozzCorpus.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportGlozzCorpus.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportGlozzCorpus.java	(revision 927)
@@ -34,15 +34,15 @@
 
 
 
-//	@Option(name="aafile",usage="an example file", widget="File", required=true, def="text.aa")
-//	File aafile;
+	//	@Option(name="aafile",usage="an example file", widget="File", required=true, def="text.aa")
+	//	File aafile;
 
-//	@Option(name="acfile",usage="an example file", widget="File", required=true, def="annotations.ac")
-//	File acfile
-	
+	//	@Option(name="acfile",usage="an example file", widget="File", required=true, def="annotations.ac")
+	//	File acfile
+
 	@Option(name="glozzDirectory",usage="A folder containing the Glozz files: aa ac and aam", widget="Folder", required=true, def="glozz")
 	File glozzDirectory;
-	
+
 	@Option(name="aamfile",usage="The aam file to use", widget="File", required=true, def="model.aam")
 	File aamfile;
 	private String name;
@@ -75,12 +75,12 @@
 			DeleteDir.deleteDirectory(ecDir);
 			ecDir.mkdir();
 
-			
+
 			if (!srcDir.exists()) {
 				System.out.println(Messages.ImportGlozzCorpus_4);
 				return null;
 			}
-			
+
 			if (!ecDir.exists()) {
 				System.out.println(Messages.ImportGlozzCorpus_5);
 				return null;
@@ -112,7 +112,7 @@
 				System.out.println(Messages.ImportGlozzCorpus_10+glozzDirectory);
 				return false;
 			}
-			
+
 			System.out.println(Messages.ImportGlozzCorpus_11+glozzDirectory);
 			Arrays.sort(acFiles);
 			Arrays.sort(aaFiles);
@@ -122,34 +122,34 @@
 				String name = acFile.getName();
 				int idx = name.indexOf("."); //$NON-NLS-1$
 				if (idx > 0) name = name.substring(0, idx);
-				
+
 				File txtFile = new File(srcDir, name+".txt"); //$NON-NLS-1$
 				File ecFile = new File(ecDir, name+".ec"); //$NON-NLS-1$
 				Corpus tmpAnalecCorpus = new Corpus(); // need a temporary corpus
-				
+
 				if (!FichiersGlozz.importerGlozz(tmpAnalecCorpus, acFile, aaFile)) {
 					System.out.println(Messages.ImportGlozzCorpus_15);
 					return null;
 				}
-				
+
 				final String texte = tmpAnalecCorpus.getTexte();
-			    int debParag = 0;
-			    Integer[] finPars = tmpAnalecCorpus.getFinParagraphes();
-			    StringBuffer newTexte = new StringBuffer(texte.length() + finPars.length);
-			    for (int iParagraph = 0 ; iParagraph < finPars.length ; iParagraph++) {
-			    	newTexte.append(texte.substring(debParag, finPars[iParagraph])).append("\n"); //$NON-NLS-1$
-			    	debParag = finPars[iParagraph];
-			    }
-				
+				int debParag = 0;
+				Integer[] finPars = tmpAnalecCorpus.getFinParagraphes();
+				StringBuffer newTexte = new StringBuffer(texte.length() + finPars.length);
+				for (int iParagraph = 0 ; iParagraph < finPars.length ; iParagraph++) {
+					newTexte.append(texte.substring(debParag, finPars[iParagraph])).append("\n"); //$NON-NLS-1$
+					debParag = finPars[iParagraph];
+				}
+
 				IOUtils.write(txtFile, newTexte.toString()); // write the TXT file for TXM TXT import module
 				FichiersJava.enregistrerCorpus(tmpAnalecCorpus, ecFile); // write for later
-				
+
 				if (!txtFile.exists()) {
 					System.out.println(Messages.ImportGlozzCorpus_17);
 					return null;
 				}
 			}
-			
+
 			File paramFile = new File(srcDir, "import.xml"); //$NON-NLS-1$
 			BaseParameters.createEmptyParams(paramFile, name.toUpperCase());
 
@@ -177,54 +177,58 @@
 				return null;
 			}
 
-//			System.out.println("Waiting for import to finish...");
-//			job.join();
-//			System.out.println("Waiting for import done.");
-			
+			//			System.out.println("Waiting for import to finish...");
+			//			job.join();
+			//			System.out.println("Waiting for import done.");
+
 			JobHandler job2 = new JobHandler(Messages.ImportGlozzCorpus_24) {
-				
+
 				@Override
 				protected IStatus run(IProgressMonitor monitor) {
 					try {
-					Corpus analecCorpus = AnalecCorpora.getCorpus(name.toUpperCase());
-					analecCorpus.clearAll(); // remove all : annotations, structure
-					File[] ecFiles = ecDir.listFiles();
-					Arrays.sort(ecFiles);
-					for (File ecFile : ecFiles) {
-						FichiersJava.concatener(ecFile, analecCorpus);
-					}
-					
-					System.out.println(Messages.ImportGlozzCorpus_25+aamfile);
-					if (!FichiersGlozz.importerModeleGlozz(analecCorpus, aamfile)) {
-						System.out.println(Messages.ImportGlozzCorpus_26);
-						return null;
-					}
-//					
-//					System.out.println("Importing Glozz corpus from: "+acfile+" and "+aafile);
-//					if (!FichiersGlozz.importerGlozz(analecCorpus, acfile, aafile)) {
-//						System.out.println("Error while importing Glozz corpus.");
-//						return null;
-//					}
-					
-					System.out.println(Messages.ImportGlozzCorpus_27);
-					MainCorpus corpus = CorpusManager.getCorpusManager().getCorpus(name.toUpperCase());
-					AnalecCorpora.removeCorpus(corpus.getName()); // remove old corpus if any
-					
-					AnalecAnnotationReIndexer aari = new AnalecAnnotationReIndexer(corpus, analecCorpus);
-					if (!aari.process()) {
-						System.out.println(Messages.ImportGlozzCorpus_28);
-						return null;
-					}
-					
-					System.out.println(Messages.ImportGlozzCorpus_29);
-					AnalecCorpora.saveCorpus(analecCorpus);
-					AnalecCorpora.getVue(analecCorpus).retablirVueParDefaut();
-					System.out.println(Messages.ImportGlozzCorpus_30);
-					analecCorpus.setTexte(""); // free memory //$NON-NLS-1$
-					DeleteDir.deleteDirectory(ecDir); // cleaning
-					DeleteDir.deleteDirectory(srcDir); // cleaning
-					
-					return Status.OK_STATUS;
+						MainCorpus corpus = CorpusManager.getCorpusManager().getCorpus(name.toUpperCase());
+						if (corpus == null) {
+							System.out.println("The CQP corpus was not created. Aborting.");
+							return Status.CANCEL_STATUS;
+						}
+						Corpus analecCorpus = AnalecCorpora.getCorpus(corpus);
+						analecCorpus.clearAll(); // remove all : annotations, structure
+						File[] ecFiles = ecDir.listFiles();
+						Arrays.sort(ecFiles);
+						for (File ecFile : ecFiles) {
+							FichiersJava.concatener(ecFile, analecCorpus);
+						}
+
+						System.out.println(Messages.ImportGlozzCorpus_25+aamfile);
+						if (!FichiersGlozz.importerModeleGlozz(analecCorpus, aamfile)) {
+							System.out.println(Messages.ImportGlozzCorpus_26);
+							return Status.CANCEL_STATUS;
+						}
+						//					
+						//					System.out.println("Importing Glozz corpus from: "+acfile+" and "+aafile);
+						//					if (!FichiersGlozz.importerGlozz(analecCorpus, acfile, aafile)) {
+						//						System.out.println("Error while importing Glozz corpus.");
+						//						return null;
+						//					}
+
+						System.out.println(Messages.ImportGlozzCorpus_27);
+						AnalecCorpora.removeCorpus(corpus); // remove old corpus if any
+
+						AnalecAnnotationReIndexer aari = new AnalecAnnotationReIndexer(corpus, analecCorpus);
+						if (!aari.process()) {
+							System.out.println(Messages.ImportGlozzCorpus_28);
+							return Status.CANCEL_STATUS;
+						}
+
+						System.out.println(Messages.ImportGlozzCorpus_29);
+						AnalecCorpora.saveCorpus(analecCorpus);
+						AnalecCorpora.getVue(analecCorpus).retablirVueParDefaut();
+						System.out.println(Messages.ImportGlozzCorpus_30);
+						analecCorpus.setTexte(""); // free memory //$NON-NLS-1$
+						DeleteDir.deleteDirectory(ecDir); // cleaning
+						DeleteDir.deleteDirectory(srcDir); // cleaning
+
+						return Status.OK_STATUS;
 					} catch (Exception e) {
 						System.out.println(Messages.ImportGlozzCorpus_32+e.getLocalizedMessage());
 						Log.printStackTrace(e);
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadVue.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadVue.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadVue.java	(revision 927)
@@ -44,7 +44,7 @@
 	
 	public boolean load(MainCorpus mainCorpus) {
 		System.out.println(Messages.LoadVue_1+mainCorpus.getName());
-		Vue vue = AnalecCorpora.getVue(mainCorpus.getName());
+		Vue vue = AnalecCorpora.getVue(mainCorpus);
 		if (!FichiersJava.ouvrirVue(vue)) {
 			System.out.println(Messages.LoadVue_2);
 			return false;
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadStructure.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadStructure.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadStructure.java	(revision 927)
@@ -34,7 +34,7 @@
 		}
 		
 		MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
-		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus);
 //		if (VisuStructure.isOpen()) {
 //			System.out.println("Structure de corpus en cours d'édition. Abandon.");
 //			return null;
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/EditVue.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/EditVue.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/EditVue.java	(revision 927)
@@ -36,7 +36,7 @@
 		}
 		
 		MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
-		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus);
 		vue = AnalecCorpora.getVue(corpus);
 
 		javax.swing.SwingUtilities.invokeLater(new Runnable() {
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/EditStructure.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/EditStructure.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/EditStructure.java	(revision 927)
@@ -35,7 +35,7 @@
 		}
 		
 		MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
-		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus);
 
 		//System.out.println("Editing structure for corpus="+corpus);
 
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportTEICorpus.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportTEICorpus.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/ImportTEICorpus.java	(revision 927)
@@ -127,7 +127,7 @@
 					MainCorpus corpus = CorpusManager.getCorpusManager().getCorpus(name.toUpperCase());
 					File analecDirectory = new File(corpus.getBaseDirectory(), "analec"); //$NON-NLS-1$
 					analecDirectory.mkdirs();
-					Corpus analecCorpus = AnalecCorpora.getCorpus(name.toUpperCase());
+					Corpus analecCorpus = AnalecCorpora.getCorpus(corpus);
 					analecCorpus.clearAll(); // remove all : annotations, structure
 					
 					System.out.println(Messages.ImportTEICorpus_18+xmlFile);
@@ -138,7 +138,7 @@
 				
 					System.out.println(Messages.ImportTEICorpus_20);
 					
-					AnalecCorpora.removeCorpus(corpus.getName()); // remove old corpus if any
+					AnalecCorpora.removeCorpus(corpus); // remove old corpus if any
 					
 					AnalecAnnotationReIndexer aari = new AnalecAnnotationReIndexer(corpus, analecCorpus);
 					if (!aari.process()) {
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveStructureAsGlozzModel.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveStructureAsGlozzModel.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/SaveStructureAsGlozzModel.java	(revision 927)
@@ -26,7 +26,7 @@
 		
 		MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
 		
-		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus);
 
 //		if (VisuStructure.isOpen()) {
 //			System.out.println("Structure de corpus en cours d'édition. Abandon.");
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadStructureFromGlozz.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadStructureFromGlozz.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadStructureFromGlozz.java	(revision 927)
@@ -32,7 +32,7 @@
 		}
 		
 		MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
-		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus);
 		
 //		if (VisuStructure.isOpen()) {
 //			System.out.println("Structure de corpus en cours d'édition. Abandon.");
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadCorpus.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadCorpus.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/commands/LoadCorpus.java	(revision 927)
@@ -42,7 +42,7 @@
 		}
 		
 		MainCorpus mainCorpus = ((org.txm.searchengine.cqp.corpus.Corpus)first).getMainCorpus();
-		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus.getName());
+		Corpus corpus = AnalecCorpora.getCorpus(mainCorpus);
 		
 		System.out.println(Messages.LoadCorpus_1);
 		
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/export/ExportToGlozzMacro.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/export/ExportToGlozzMacro.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/export/ExportToGlozzMacro.java	(revision 927)
@@ -94,7 +94,7 @@
 
 		// note that unit_type has been defined with an option of the dialog at
 		// the beginning
-		Corpus analecCorpus = AnalecCorpora.getCorpus(corpus.getName());
+		Corpus analecCorpus = AnalecCorpora.getCorpus(corpus);
 
 		// list of properties
 
Index: tmp/org.txm.analec.rcp/src/org/txm/analec/toolbar/URSAnnotationToolbar.java
===================================================================
--- tmp/org.txm.analec.rcp/src/org/txm/analec/toolbar/URSAnnotationToolbar.java	(revision 926)
+++ tmp/org.txm.analec.rcp/src/org/txm/analec/toolbar/URSAnnotationToolbar.java	(revision 927)
@@ -69,8 +69,8 @@
 
 		this.editor = (SynopticEditionEditor) txmeditor;
 		this.maincorpus = (MainCorpus) this.editor.getCorpus();
-		analecCorpus = AnalecCorpora.getCorpus(maincorpus.getName());
-		vue = AnalecCorpora.getVue(maincorpus.getName());
+		analecCorpus = AnalecCorpora.getCorpus(maincorpus);
+		vue = AnalecCorpora.getVue(maincorpus);
 
 		annotationArea = new GLComposite(parent, SWT.NONE, "Unit annotation");
 
@@ -211,8 +211,8 @@
 	public boolean discardChanges() {
 		if (maincorpus.isModified()) {
 			AnalecCorpora.revert(maincorpus);
-			analecCorpus = AnalecCorpora.getCorpus(maincorpus.getName());
-			vue = AnalecCorpora.getVue(maincorpus.getName());
+			analecCorpus = AnalecCorpora.getCorpus(maincorpus);
+			vue = AnalecCorpora.getVue(maincorpus);
 			analecCorpus.removeEventListener(corpusListener);
 			CorporaView.refreshObject(maincorpus);
 		}
Index: tmp/org.txm.treetagger.core/src/org/txm/treetagger/core/TreeTaggerEngine.java
===================================================================
--- tmp/org.txm.treetagger.core/src/org/txm/treetagger/core/TreeTaggerEngine.java	(revision 0)
+++ tmp/org.txm.treetagger.core/src/org/txm/treetagger/core/TreeTaggerEngine.java	(revision 927)
@@ -0,0 +1,108 @@
+package org.txm.treetagger.core;
+
+import java.io.File;
+import java.util.HashMap;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.txm.annotation.core.AnnotationEngine;
+import org.txm.importer.xmltxm.Annotate;
+import org.txm.treetagger.core.preferences.TreeTaggerPreferences;
+import org.txm.utils.treetagger.TreeTagger;
+
+public class TreeTaggerEngine extends AnnotationEngine {
+
+	private File ttModelsDirectory;
+	private File ttBinaryDirectory;
+
+	protected HashMap<File, TreeTagger> instances = new HashMap<File, TreeTagger>();
+	private String[] options;
+
+	@Override
+	public boolean isRunning() {
+		
+		ttBinaryDirectory = new File(TreeTaggerPreferences.getString(TreeTaggerPreferences.INSTALL_PATH, TreeTaggerPreferences.PREFERENCES_NODE)+"/bin/");
+		if (!ttBinaryDirectory.exists()) {
+			System.out.println("Error: path to TreeTagger is wrong: "+ttBinaryDirectory);
+			return false;
+		}
+		
+		ttModelsDirectory = new File(TreeTaggerPreferences.getString(TreeTaggerPreferences.MODELS_PATH, TreeTaggerPreferences.PREFERENCES_NODE));
+		if (!ttModelsDirectory.exists()) {
+			System.out.println("Error: path to TreeTagger path is wrong: "+ttModelsDirectory);
+			return false;
+		}
+		
+		options = TreeTaggerPreferences.getString(TreeTaggerPreferences.OPTIONS, TreeTaggerPreferences.PREFERENCES_NODE).split("  ");
+		
+		return ttBinaryDirectory != null && ttBinaryDirectory.exists() && ttModelsDirectory != null && ttModelsDirectory.exists();
+	}
+	
+	@Override
+	public boolean stop() throws Exception {
+		ttBinaryDirectory = null;
+		ttModelsDirectory = null;
+		for (TreeTagger tt : instances.values()) {
+			tt.kill();
+		}
+		instances.clear();
+		return false;
+	}
+
+	@Override
+	public String getName() {
+		return "TreeTagger";
+	}
+
+	@Override
+	public boolean initialize() {
+		return true;
+	}
+
+	@Override
+	public boolean start(IProgressMonitor monitor) {
+		return true;
+	}
+
+	public TreeTagger getInstance(File modelFile) {
+		if (!instances.containsKey(modelFile)) {
+			instances.put(modelFile, new TreeTagger(ttBinaryDirectory.getAbsolutePath(), options));
+		}
+		return instances.get(modelFile);
+	}
+
+	@Override
+	public boolean processFile(File xmlFile, File binaryCorpusDirectory, HashMap<String, Object> parameters) {
+		if (!isRunning()) return false;
+		
+		Annotate annotate = new Annotate();
+		Object p = parameters.get("lang");
+		if (p == null) {
+			System.out.println("Error: no 'lang' parameter given. Aborting TreeTagger annotation.");
+			return false;
+		}
+		String lang = p.toString();
+		
+		return annotate.run(xmlFile, lang, binaryCorpusDirectory, xmlFile.getParentFile());
+	}
+
+	/**
+	 * if the 'langs' HashMap<String=xml file path, String=lang code> parameter is set, then the Annotate class will do multi-threading to process the files
+	 * 
+	 * @return true if success
+	 */
+	public boolean processDirectory(File xmlFilesDirectory, File binaryCorpusDirectory, HashMap<String, Object> parameters) {
+		Object p = parameters.get("langs");
+		if (p != null && p instanceof HashMap<?,?>) {
+			Annotate annotate = new Annotate();
+			HashMap<String, String> langs = (HashMap<String, String>) p;
+			return annotate.run(binaryCorpusDirectory, new File(binaryCorpusDirectory, "txm"), langs);
+		} else {
+			return super.processDirectory(xmlFilesDirectory, binaryCorpusDirectory, parameters);
+		}
+	}
+	
+	@Override
+	public boolean isAutomatic() {
+		return true;
+	}
+}

